Summary: This RPM will configure a Linux based computer to be compatible with both the Heimdal and Active Directory realms. 
Name: cern-kerberos-migration
Version: 0.1
Release: 12%{?dist}
License: distributable
Group: System Environment/Daemons
Buildroot: /tmp/%{name}
Source0: %{name}-%{version}.tgz

BuildRequires: pam-devel
BuildRequires: krb5-devel
Requires: arc >= 44-38.cern
Requires: cern-config-keytab >= 1-40.cern
Requires: net-tools           
# for /bin/hostname

%description
This rpm will enable the machine to accept Kerberos authentication requests from both the CERN Active Directory and Heimdal realms, and to authenticate against both realms. The default /etc/krb5.conf remains the same, ensuring that the machine and any user will be in the Heimdal realm by default. Changing the KRB5_CONFIG variable to /etc/krb5.conf.windows in a shell will switch it to authenticate against the AD realm. 

This is a temporary setup, which will remain in place for the duration of the migration, allowing machines and users of machines to be recognised in both realms.

%prep 
%setup -c

%build
make

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/%{_lib}/security
install -m 755 pam_ensure_correct_realm.so $RPM_BUILD_ROOT/%{_lib}/security

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}
install -m 644 krb5.conf.linux $RPM_BUILD_ROOT/%{_sysconfdir}
install -m 644 krb5.conf.windows $RPM_BUILD_ROOT/%{_sysconfdir}

%clean
rm -rf $RPM_BUILD_ROOT

%pre

%post
if ! grep -q 'cern-kerberos-migration'  %{_sysconfdir}/pam.d/system-auth; then 
  echo "# added by cern-kerberos-migration rpm" >> %{_sysconfdir}/pam.d/system-auth
  echo "session    optional     pam_ensure_correct_realm.so" >> %{_sysconfdir}/pam.d/system-auth
fi
# Only run cern-config-keytab if 1) we are at CERN, 2) the machine already has a keytab
#[ `/bin/hostname -d` == 'cern.ch' ] && [ -e /etc/krb5.keytab ] && /usr/bin/cern-config-keytab -f

if [ `/bin/hostname -d` == 'cern.ch' ] && [ -e /etc/krb5.keytab ]; then
    if [ `/usr/bin/stat -c %a /etc/krb5.keytab` -ne 600 ]; then
        /usr/bin/cern-config-keytab -rx
    elif [ -e /etc/krb5.keytab.linux ] && [ `/usr/bin/stat -c %a /etc/krb5.keytab.linux` -ne 600 ]; then 
        /usr/bin/cern-config-keytab -rx
    elif [ -e /etc/krb5.keytab.windows ] && [ `/usr/bin/stat -c %a /etc/krb5.keytab.windows` -ne 600 ]; then
        /usr/bin/cern-config-keytab -rx
    else
        /usr/bin/cern-config-keytab -f
    fi
fi

exit 0
%preun

%postun
if [ "$1" = "0" ]; then  # only on our way out
  # remove the gunk we added..
  sed -i -e '/cern-kerberos-migration/d' -e '/pam_ensure_correct_realm/d'  %{_sysconfdir}/pam.d/system-auth

  [ `/bin/hostname -d` == 'cern.ch' ] && [ -e /etc/krb5.keytab ] && /usr/bin/cern-config-keytab -f
fi
exit 0

%files
%defattr(-,root,root)
/%{_lib}/security/pam_ensure_correct_realm.so
/%{_sysconfdir}/krb5.conf.linux
/%{_sysconfdir}/krb5.conf.windows
%changelog
* Mon Dec 12 2010 John Hefferman <john.hefferman@cern.ch> 1.0p1-11
krb5.conf files modified for slc6 compatability (allow_weak_crypto and dns kdc lookup)
* Tue Oct 26 2010 John Hefferman <john.hefferman@cern.ch> 1.0p1-9
John Hefferman - Changed script to do a key refresh in the case of incorrect file permissions
* Tue Oct 12 2010 John Hefferman <john.hefferman@cern.ch> 1.0p1-9
John Hefferman - Changed setting of KRB5CCNAME variable to avoid problems with su
* Fri Oct 8 2010 John Hefferman <john.hefferman@cern.ch> 1.0p1-8
John Hefferman - Reduced the number of messages logged
* Tue Oct 5 2010 Jaroslaw Polok <jaroslaw.polok@cwern.ch> 1.0p1-7 
- minor specfile adjustments
* Wed Aug 4 2010 John Hefferman <john.hefferman@cern.ch> 1.0p1-6
John Hefferman - Acquires afs token if not previously acquired by pam_krb5 due to TGT / krb5.conf mismatch. Required because 'krb5_init_secure_context' in pam_krb5 ignores the environment configured by this module.
John Hefferman - No longer print cern-config-keytab verbose messages
John Hefferman - Runs cern-config-keytab on removal to ensure machine is left with valid credentials
John Hefferman - Logging now directed to /var/log/secure
* Mon Jul 6 2010 John Hefferman <john.hefferman@cern.ch> 1.0p1-5
John Hefferman - Changed to prevent pam_sm_close_session errors being written to /var/log/secure.
John Hefferman - Changed pam_ensure_correct_realm to only change the default KRB5_CONFIG if absolutely necessary.
* Mon Jun 14 2010 John Hefferman <john.hefferman@cern.ch> 1.0p1-4
John Hefferman - Changed the script to only run cern-config-keytab if a keytab already exists. To prevent unnecessary load on the extraction servers.
* Mon Jan 31 2010 John Hefferman <jan.iven@cern.ch> 1.0p1-3
Jan Iven - Changed the pam module to dynamically link the kerberos libs
Jan Iven - Changed the post section to remove any previous references to the pam module in system-auth
* Mon Jan 31 2010 John Hefferman <john.hefferman@cern.ch> 1.0p1-2
John Hefferman - Changed the initial comment in krb5.conf.windows to ; instead of #. A # comment would not be recognised on SLC4
John Hefferman - Changed the .spec to insert the pam_ensure_correct_realm call into system-auth instead of sshd
* Thu Jan 6 2010 John Hefferman <john.hefferman@cern.ch> 1.0p1-1
John Hefferman - Changed the pam module according to security team's suggestions

